local mod = RW:Boss("Ragnaros", "Firelands")
local L
local LBB

mod.BossIcon = [[Interface\EncounterJournal\UI-EJ-BOSS-Ragnaros]]

---------------------------
-- Variables
local RoleBits = RW.Utils.Constants.RoleBits

---------------------------
-- Init
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L

	LBB = RW.LBB

	self:SetTrigger(52409)
	self:SetWin()
	
	self:RegisterAlert("mWound", self:TargetStackMessage(101238, nil, nil, bit.bor(RoleBits.TANK, RoleBits.HEALER)))
	self:RegisterAlert("tWoundDur", self:DurTargetStackTimer(20, 101238, nil, nil, bit.bor(RoleBits.TANK, RoleBits.HEALER)))
	
	self:RegisterAlert("tSeedsCD", self:CDTimer(60, 98498))
	self:RegisterAlert("wSeedsRun", self:RunawayWarning(98498))
end

---------------------------
-- Locals
local seedSpellName = GetSpellInfo(98498)
local lastSeed = 0

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Wound", 101238, 101239, 101240, 99399)
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end

function mod:Wound(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		self:Call("mWound", "Show", args.dName, args.amount or 1)
		self:Call("tWoundDur", "Start", args.dName, args.amount or 1)
	end
end

function mod:UNIT_SPELLCAST_SUCCEEDED(event, unit, spellName, rank, line, spellID)
	if spellName == seedSpellName then
		local t = GetTime()
		if t - lastSeed > 5 then 
			self:Call("wSeedsRun", "Show")
			self:Call("tSeedsCD", "Start")
			lastSeed = t
		end
	end
end
